proc iml;
	reset storage=pj1a.data4a_matrix;
	load u v t N;
	dgr = 3;
	nknot_u = 1;
	nknot_v = 1;
	nknot_t = 6;

	u_min = u[><,];
	u_max = u[<>,];
	v_min = v[><,];
	v_max = v[<>,];
	t_min = t[><,];
	t_max = t[<>,];

	knot_u = repeat(u_min,1,dgr-1) || do(u_min,u_max,(u_max-u_min)/(nknot_u+1)) 
				|| repeat(u_max,1,dgr-1);
	knot_v = repeat(v_min,1,dgr-1) || do(v_min,v_max,(v_max-v_min)/(nknot_v+1)) 
				|| repeat(v_max,1,dgr-1);
	knot_t = repeat(t_min,1,dgr-1) || do(t_min,t_max,(t_max-t_min)/(nknot_t+1)) 
				|| repeat(t_max,1,dgr-1);

	knot_u = round(knot_u,1e-3);
	knot_v = round(knot_v,1e-3);
	knot_t = round(knot_t,1e-3);

	reset storage=pj1a.sim1_module; load module=(center);
	reset storage=pj1a.data4a_matrix;
	use pj1a.uv_bound_a(where=(bound=2)); read all var {u v}; close;

	uv_grid = u || v;
	uv_grid = round(uv_grid,1e-6);
	t_grid = do(0.05,1.95,0.01)`;

	dgr = 3;

	c_u = bspline(uv_grid[,1],dgr,knot_u);
	c_v = bspline(uv_grid[,2],dgr,knot_v);
	c_uv = (c_u@j(1,ncol(c_v),1)) # (j(1,ncol(c_u),1)@c_v);

	c_t = bspline(t_grid,dgr,knot_t);

/**********************************************************************************************/

	z_uv = center(c_uv[:,]`);
	c_uv_grid = c_uv * z_uv;

	z_t = center(c_t[:,]`);
	c_t_grid = c_t * z_t;

/**********************************************************************************************/

	store knot_u knot_v knot_t uv_grid t_grid z_uv z_t c_uv_grid c_t_grid;
quit;

