proc iml;
	reset storage=pj1a.sim1_module; load module=(penalty);
	reset storage=pj1a.data4a_matrix;

	load u v t N knot_t knot_u knot_v z_uv z_t;
	dgr = 3;

	c_u = bspline(u,dgr,knot_u);
	c_v = bspline(v,dgr,knot_v);
	c_uv = (c_u@j(1,ncol(c_v),1)) # (j(1,ncol(c_u),1)@c_v);

	c_t = bspline(t,dgr,knot_t);

/**********************************************************************************************/

	c_uv_z = c_uv * z_uv;
	nb_uv = ncol(c_uv_z);

	c_t_z = c_t * z_t;
	nb_t = ncol(c_t_z);

	c_z = j(N,1,1) || c_uv_z || c_t_z;
	nb = ncol(c_z);

/**********************************************************************************************/

	ngrid_u = ncol(c_u);
	ngrid_v = ncol(c_v);

	u_min = u[><,];
	u_max = u[<>,];
	v_min = v[><,];
	v_max = v[<>,];

	c_u2 = bspline(do(u_min,u_max,(u_max-u_min)/ngrid_u),dgr,knot_u);
	c_v2 = bspline(do(v_min,v_max,(v_max-v_min)/ngrid_v),dgr,knot_v);

/**********************************************************************************************/

	B_u = penalty(ncol(c_u));
	B_v = penalty(ncol(c_v));

	B_uv_z = (B_u @ c_v2) * z_uv;
	B_vu_z = (c_u2 @ B_v) * z_uv;

	B_t = penalty(ncol(c_t));
	B_t_z = B_t * z_t;

/**********************************************************************************************/

	B_vec = btran(B_uv_z,1,nb_uv) || btran(B_vu_z,1,nb_uv) || btran(B_t_z,1,nb_t);
	B_vec = B_vec`;

	len_Buv = nb_uv # nrow(B_uv_z);
	len_Bvu = nb_uv # nrow(B_vu_z);
	len_Bt = nb_t # nrow(B_t_z);

	idx1 = {1} // (len_Buv + 1) // (len_Buv + len_Bvu + 1);
	idx2 = len_Buv // (len_Buv + len_Bvu) // (len_Buv + len_Bvu + len_Bt); 
	idx3 = nb_uv // nb_uv // nb_t;
	idx4 = {1} // {1} // (nb_uv + 1);
	idx4 = idx4 + 1;
	idx5 = nb_uv // nb_uv // (nb_uv + nb_t);
	idx5 = idx5 + 1;

	B_vec_idx = idx1 || idx2 || idx3 || idx4 || idx5;

/**********************************************************************************************/

	store c_uv_z c_t_z c_z nb_uv nb_t nb B_uv_z B_vu_z B_t_z B_vec B_vec_idx;
quit;
