%let outpfx = pj1a.data4a;
%let outsfx = est;

proc iml;
	reset storage=pj1a.sim1_module; load module=(E M_QR M_SVD M_drho GCVr M_rho);
	reset storage=pj1a.data4a_matrix;
	load y l s Ny N c_z nb B_uv_z B_vu_z B_t_z B_vec B_vec_idx;

	reset storage=work.pj1a_data4a;
	b = j(nb-1,Ny,0);
	rho = j(nrow(B_vec_idx),Ny,0);
	store y l s Ny N c_z nb B_uv_z B_vu_z B_t_z B_vec B_vec_idx b rho;
	free y l s Ny N c_z nb B_uv_z B_vu_z B_t_z B_vec B_vec_idx b rho;

	/******************************************************************************************/

	load y l s Ny N b rho;

	/*Loop 1*/
	iter = 0;
	lkhd0 = 0;
	do until(diff < 1e-4 | iter >= 500);
	iter = iter + 1;

	load c_z;

	th = l` // b;
	l_f = c_z * th;

	eta = j(N,2,.);
	lkhd = 0;
	run E(y,l_f,s,N,eta,lkhd);

	diff = abs(lkhd - lkhd0);
	lkhd0 = lkhd; free lkhd;

	/******************************************************************************************/

	load nb;

	eta1 = eta[,1];
	eta2 = eta[,2];
	free eta;

	X1 = c_z # eta1;
	X2 = c_z # sqrt(eta2);
	store X1 X2;
	free c_z eta1 eta2 X1 X2;

	/*Loop 1a*/
	do p = 1 to Ny;
	rho_p = rho[,p];
	load X1 X2;

	r1 = .; r2 = .; qy = .;
	run M_QR(y[,p],X1,X2,nb,r1,r2,qy);
	store r1 r2 qy;
	free X1 X2 r1 r2 qy;

	/*Loop 2*/
	iter_r = 0;
	GCV_0 = .; GCVr_0 = .; rho_0 = .; 
	do until(diff_r < 1e-4 | iter_r >= 10); 
	iter_r = iter_r + 1;

	/******************************************************************************************/

	/*Loop 3*/
	iter_r2 = 0;
	opt = 1;
	GCV_min = .; d_rho = .;
	do until(GCV_min | iter_r2 >= 10);
	iter_r2 = iter_r2 + 1;

	load B_uv_z B_vu_z B_t_z X1 r1 r2 qy;

	om = exp(rho_p);
	call eigen(eval, evec, om[1]#(B_uv_z`*B_uv_z) + om[2]#(B_vu_z`*B_vu_z)); 
	Bm_uv = sqrt(eval) # evec`; 
	Bm_t = sqrt(om[3])#B_t_z; 
	Bm = block(Bm_uv, Bm_t);
	RBm = r1 // r2  // (j(nb-1,1,0) || Bm);
	free om B_uv_z B_vu_z B_t_z eval evec r1 r2 Bm;

	Pm_inv = .; UU1 = .; uqy = .; 
	dt1 = .; dt2 = .; GCV = .;
	lp = .; sp = .; bp = .;
	run M_SVD(RBm,y[,p],X1,qy,nb,N,Pm_inv,UU1,uqy,dt1,dt2,GCV,lp,sp,bp);
	free RBm X1 qy;

	run M_drho(rho_p,rho_0,GCV,GCV_0,GCVr_0,GCV_min,d_rho,opt,iter_r,iter_r2);

	/*Loop 3*/end;
	free iter_r2 opt GCV_min d_rho;

	/******************************************************************************************/

	load B_vec B_vec_idx;
	GCVr = .; GCVrr = .;
	run GCVr(nb,B_vec,B_vec_idx,Pm_inv,UU1,uqy,dt1,dt2,rho_p,GCVr,GCVrr);

	GCV_0 = GCV;;
	GCVr_0 = GCVr;
	rho_0 = rho_p;
	GCV_out = GCV_out // (iter || p || iter_r || GCV || GCVr`);
	free B_vec B_vec_idx Pm_inv UU1 uqy dt1 dt2 GCV;

	/******************************************************************************************/

	run M_rho(rho_p,GCVr,GCVrr,-20,10);
	diff_r = sqrt(ssq(rho_p - rho_0)); 
	free GCVr GCVrr;

	/*Loop 2*/end;
	free iter_r diff_r GCV_0 GCVr_0 rho_0;
	remove qy r1 r2;

	l[p,] = lp;
	s[p,] = sp;
	b[,p] = bp;
	rho[,p] = rho_p;
	free lp sp bp rho_p;

	/*Loop 1a*/end;
	remove X1 X2;

	/*Loop 1*/end;

	/******************************************************************************************/

	reset storage=pj1a.data4a_matrix; 
	load cn_l cn_s cn_b_uv cn_b_t cn_r cn_GCV;

	l = iter || l`;
	s = iter || s`;
	b = repeat(iter,Ny,1) || do(1,Ny,1)` || b`;
	rho = repeat(iter,Ny,1) || do(1,Ny,1)` || rho`;

	create &outpfx._l_&outsfx from l[c=({'iter'}||cn_l`)]; append from l; close;
	create &outpfx._s_&outsfx from s[c=({'iter'}||cn_s`)]; append from s; close;
	create &outpfx._b_&outsfx from b[c=({'iter' 'p'}||cn_b_uv`||cn_b_t`)]; append from b; close;
	create &outpfx._rho_&outsfx from rho[c=({'iter' 'p'}||cn_r`)]; append from rho; close;
	create &outpfx._GCV_&outsfx from GCV_out[c=({'iter' 'p' 'iter_r' 'GCV'}||cn_GCV`)];
		append from GCV_out; close;
quit;
