proc iml;
	start center(c);
		call qr(q, r, piv, lindep, c);
		nr = nrow(c);
		nc = ncol(c);
		z = q[,nc+1:nr];
		free q r piv lindep c;
		return (z);
	finish;

	start penalty(d);
		B = (i(d-1)||j(d-1,1,0))+(j(d-1,1,0)||-1#i(d-1));
		return (B);
	finish;

	start E(mm_y,mm_l,mm_s,mm_N,mm_eta,mm_lkhd);
		do i = 1 to mm_N;
			l_i = mm_l[i,]`;
			inv_vy = inv(l_i*l_i` + diag(mm_s));
			y_i = mm_y[i,]`;

			eta = l_i` * inv_vy * y_i;
			eta2 = 1 - (l_i` * inv_vy * l_i);
			mm_lkhd = mm_lkhd - (y_i` * inv_vy * y_i) + log(det(inv_vy));
			mm_eta[i,] = eta || eta2;
			free l_i inv_vy y_i eta eta2;
		end;
	finish;

	start M_QR(mm_y,mm_X1,mm_X2,mm_nb,mm_r1,mm_r2,mm_qy);
		call qr(mm_qy, mm_r1, piv, lindep, mm_X1, , mm_y);
		mm_qy = mm_qy[1:mm_nb,];
		free piv lindep;

		call qr(q, mm_r2, piv, lindep, mm_X2, , j(nrow(mm_X2),1,1));
		free piv lindep;
	finish;
	
	start M_SVD(mm_RBm,mm_y,mm_X1,mm_qy,mm_nb,mm_N,
				mm_Pm_inv,mm_UU1,mm_uqy,mm_dt1,mm_dt2,mm_GCV,mm_l,mm_s,mm_b)
	;
		call svd(Um,Dm,Vm,mm_RBm);

		idx_UU1 = 1 : mm_nb;
		mm_UU1 = Um[idx_UU1,]` * Um[idx_UU1,];
		mm_Pm_inv = (1/Dm)` # Vm;
		mm_uqy = Um[idx_UU1,]` * mm_qy;
		free Dm Vm;

		idx_UU2 = mm_nb+1 : mm_nb+mm_nb;
		UU2 = Um[idx_UU2,]` * Um[idx_UU2,];
		mm_s = (mm_y[##,] + mm_uqy`*(mm_UU1+UU2-2#i(mm_nb))*mm_uqy) / mm_N;
		th = mm_Pm_inv * mm_uqy;
		free Um UU2;

		mm_l = th[1,];
		if mm_nb > 1 then mm_b = th[2:mm_nb,];

		mm_dt1 = mm_N - trace(mm_UU1);
		mm_dt2 = ssq(mm_y - mm_X1*th);
		mm_GCV = mm_N#mm_dt2/(mm_dt1##2); 
	finish;

	start M_drho(mm_rho,mm_rho0,mm_GCV,mm_GCV0,mm_GCVr0,mm_GCVm,mm_drho,mm_opt,mm_ir,mm_ir2);
		if mm_ir = 1 then mm_GCVm = 1;
		else if mm_GCV > mm_GCV0 then do;
			mm_GCVm = 0;
			if mm_opt = 1 then do;
				mm_rho = mm_rho0 + (mm_rho-mm_rho0)/2;
				if mm_ir2 = 3 then do; 
					mm_opt = 2;
					mm_drho = sqrt(ssq(mm_rho-mm_rho0))/sqrt(ssq(mm_GCVr0));
				end;
			end;
			else if mm_opt = 2 then do; 
				mm_rho = mm_rho0 - (mm_GCVr0#mm_drho);
				mm_drho = mm_drho / 2;
			end;
		end;
		else mm_GCVm = 1;
	finish;

	start GCVr(mm_nb,mm_Bvec,mm_Bidx,mm_Pm_inv,mm_UU1,mm_uqy,mm_dt1,mm_dt2,mm_rho,
				mm_GCVr,mm_GCVrr)
	;
		om = exp(mm_rho);

		Nf = nrow(mm_rho); 
		P_y = j(mm_nb,Nf,.);
		PUU_y = j(mm_nb,Nf,.);
		dt1r = j(Nf,1,.);
		dt2r = j(Nf,1,.);
		dt1rr = j(Nf,Nf,.);
		dt2rr = j(Nf,Nf,.);

		do i=1 to Nf;
			Bm = btran(mm_Bvec[mm_Bidx[i,1]:mm_Bidx[i,2],],mm_Bidx[i,3],1);
			Bm = Bm`;
			BP_i = Bm * mm_Pm_inv[mm_Bidx[i,4]:mm_Bidx[i,5],];
			free Bm;

			P_i = BP_i` * BP_i;
			free BP_i;
	        PS = PS || P_i; 
			free P_i;
			
			pxi = mm_nb#(i-1)+1 : mm_nb#i;
			P_y[,i] = PS[,pxi] * mm_uqy;
			PUU = PS[,pxi] * mm_UU1;
			PUU_y[,i] = PUU * mm_uqy;
			y_PUU = mm_uqy` * PUU;
			dt1r[i,] = om[i] # trace(PUU);
			dt2r[i,] = 2#om[i] # (mm_uqy`*(P_y[,i]-PUU_y[,i]));
			free pxi;

			do j=1 to i;
				pxj = mm_nb#(j-1)+1 : mm_nb#j;
				dt1rr[i,j] = (-2#om[i]#om[j] # sum(PS[,pxj]#PUU`)) + 									
								(j=i)#dt1r[i,];
				dt2rr[i,j] = ((-2#om[i]#om[j]) # (P_y[,i]`*P_y[,j] + 										
								P_y[,j]`*P_y[,i]
								- P_y[,i]`*PUU_y[,j] - P_y[,j]`*PUU_y[,i] - 								
								y_PUU*P_y[,j]))
							 	+ (j=i)#dt2r[i,]
				;
				free pxj;
			end;
			free j PUU y_PUU;
		end;

		GCVr = j(Nf,1,.);
		GCVrr = j(Nf,Nf,.);
		do i=1 to Nf;
			GCVr[i,] = dt2r[i,] - (2#mm_dt2/mm_dt1)#dt1r[i,];
			do j=1 to i;
				GCVrr[i,j] = (-2/mm_dt1)#dt2r[i,]#dt1r[j,] + dt2rr[i,j] +
						(-2/mm_dt1)#dt1r[i,]#dt2r[j,] + 
						(6#mm_dt2/(mm_dt1##2))#dt1r[i,]#dt1r[j,] +
						(-2#mm_dt2/mm_dt1)#dt1rr[i,j]
				;
			end;
		end;
		free dt1r dt2r dt1rr dt2rr;

		GCVrr = symsqr(GCVrr);
		r_idx = vecdiag(sqrsym(1:Nf#(Nf+1)/2));
		r_idx2 = loc(GCVrr[r_idx,]<0);
		if r_idx2 then do;
			r_idx = r_idx[r_idx2,]; 
			GCVrr[r_idx,] = abs(GCVrr[r_idx,]);
		end;
		free r_idx r_idx2;

		mm_GCVr = GCVr;
		mm_GCVrr = sqrsym(GCVrr);
		free GCVr GCVrr;
	finish;

	start M_rho(mm_rho,mm_GCVr,mm_GCVrr,mm_min,mm_max);
		rho = mm_rho - inv(mm_GCVrr)*mm_GCVr;
		mm_rho = rho#(rho < mm_max & rho > mm_min) + (rho >= mm_max)#mm_max + (rho <= mm_min)#mm_min;
	finish;

	reset storage=pj1a.sim1_module; 
	store module=(center penalty E M_QR M_SVD M_drho GCVr M_rho);
quit;
